/*  smpasinx.cpp  by K.Tsuru  */ 
static const char* title = "<<<<< A sample program for Asin(x) and Atan(x) functions >>>>>\n";

#include "sn.h"

void ShowCalcInfo(const SDouble& c, double cpu_time){
	cout << "Up to " << c.UpToTerm() << "th terms, cpu time = " << fixed << setprecision(3)<< cpu_time << "(sec)"<< endl;
}
void DidYouGet(double x){
	cout << endl << "Did you get a value very close to "<< x << endl;
}
void AsinTest(){
	SDouble  pi,a,b, c;
	long fig = (long)DFIGURES*(long)pi.EffFigures();
	Timer timer;
	double cpu_time;

	pi = Pi();
	printf("Calculating Asin(0.5) in %ld figures.\n", fig);
	timer.Start();
	a = Asin(0.5);
	cpu_time = timer.Stop();
	b = pi - 6*a;
	printf("\npi - 6*Asin(0.5) = ");
	b.Puts();
	DidYouGet(0.0);
	ShowCalcInfo(c, cpu_time);
	Wait();

	puts("Calculating 1/Sqrt(2.0)");
	c = RecSqrt(2);
	printf("Calculating Asin(1/Sqrt(2)) in %ld figures.\n", fig);
	timer.Start();
	a = Asin(c);
	cpu_time = timer.Stop();
	b = pi - 4*a;
	printf("\npi - 4*Asin(1/Sqrt(2)) = ");
	b.Puts();
	DidYouGet(0.0);
	ShowCalcInfo(c, cpu_time);
	Wait();
}
void AtanTest(){
	SDouble  pi,a,b, c;
	long fig = (long)DFIGURES*(long)pi.EffFigures();
	Timer timer;
	double cpu_time;

	pi = Pi();
	printf("Calculating Atan(0.5) in %ld figures.\n", fig);
	timer.Start();
	a = Atan(0.5);
	cpu_time = timer.Stop();
	ShowCalcInfo(c, cpu_time);
	Wait();

	puts("Calculating 1/Sqrt(3.0)");
	c = RecSqrt(3);
	printf("Calculating Atan(1/Sqrt(3)) in %ld figures.\n", fig);
	timer.Start();
	a = Atan(c);
	cpu_time = timer.Stop();
	b = pi - 6*a;
	printf("\npi - 6*Atan(1/Sqrt(3)) = ");
	b.Puts();
	DidYouGet(0.0);
	ShowCalcInfo(c, cpu_time);
	Wait();
}
int main(){
	RealSize C;
	uint fig;
	C.PreferSpeed(ON);
	ErrorPuts(title);
	ErrorPut("Effective figures/4 = ? ");
	fig = GetInt();
	C.SetEffFig(fig+ max(fig/100u, 10u) );
	SDouble  pi;
	long p;

	puts("Calculating pi now.");
	pi = Pi();
	C.SetEffFig(0);

	C.SetEffFig(fig);
	puts("Pi =");
	p = pi.Puts(10, 0, 5, 49);
	printf("Number of output characters = %ld.\n", p);
	Wait();

	AsinTest();
	AtanTest();

	Ending();
	return EXIT_SUCCESS;
}
