/*  smpcmpx0.cpp  by K.Tsuru  */
/*
This program compares SComplex class with C++ complex one.
It has been tested on gcc.
*/
#include "sn.h"
#include "wait.h"

static const char* const title = "A test program for SComplex class : Basic operations";

void ShowTitle(const char* func){
	cout << "****************** test of " << func << " ********************" << endl;
}

void TestMixedModeOperationPlus() {
	double p = 2.0, q = 1.5, s;
	SComplex a(p, q), b, r;

	ShowTitle("SC + double");
	s = 1.3;
	b = a + s;
	cout << a << " + " << s << " = " << b << endl;

	ShowTitle("double + SC");
	s = 11.5;
	b = s + a;
	cout << s << " + " << a << " = " << b << endl;
}
void TestMixedModeOperationMinus() {
	double p = 2.0, q = 1.5, s;
	SComplex a(p, q), b;

	ShowTitle("SC - double ");
	s = 1.3;
	b = a - s;
	cout << a << " - " << s << " = " << b << endl;

	ShowTitle("double - SC");
	s = 10;
	b = 10 - a;
	cout << s << " - " << a << " = " << b << endl;
}

void TestMixedModeOperationMult() {
	double p = 2.0, q = 1.5, s;
	SComplex a(p, q), b;

	ShowTitle("SC * double ");
	s = 1.3;
	b = a * s;
	cout << a << " * " << s <<  " = " << b << endl;

	ShowTitle("double * SC");
	s = 11.5;
	b = s * a;
	cout << s << " * " << a << " = " << b << endl;
}

void TestMixedModeOperationDiv() {
	double p = 3.0, q = 4.0, s;
	SComplex a(p, q), b;

	ShowTitle("SC / double ");
	s = 2.0;
	b = a / s;
	cout << a << " / " << s << " = "<< b << endl;

	ShowTitle("double / SC");
	s = 10;
	b = s / a;
	cout << s << " / " << a << " = " << b << endl;
}

int main(){
	RealSize C;
	C.SetEffFig(50);
	SComplex F;
	F.SetFormat(F.BracketFMT); // common format in this program

	cerr << title << endl;
	TestMixedModeOperationPlus();
	TestMixedModeOperationMinus();
	TestMixedModeOperationMult();
	TestMixedModeOperationDiv();

	Ending();
}
