/*  smpcmpx2.cpp  by K.Tsuru  */
/*
This program compares SComplex class with C++ complex one.
It has been tested on gcc.
*/
#include "sn.h"
#include "wait.h"
static const char* const title = "A test program for SComplex class";

void ShowTitle(const char* func){
	cout << "****************** test of " << func << " ********************" << endl;
}
void deMoivreFormula()
{
	cerr << "It confirms de Moivre's fromula." << endl;
	SDouble x = Pi()/16.0;
	SComplex zpow, zn, z, iz, dif;
	z.Set(Cos(x), Sin(x));

	int n, N = 10;
	cout << "  n   difference between (cos x + i* sin x)^n and cos n*x + i*sin n*x" << endl;
	for(n = -N; n<= N; n++){
		zpow = Cpow(z, n);
		zn = Cpolar(1.0, n*x);
		dif = zpow - zn;
		cout << n << "  " << dif << endl;
	}
}
void SomeIdentities()
{
	cerr << "It confirms some identities." << endl;
	SComplex z(Pi(), Sqrt(2.0)), iz, dif;
	const SComplex I(0.0, 1.0); // imaginary unit i
	iz = I*z;

	cout << "sinh(i*z)-i*sin(z) = 0 ?" << endl;
	dif = Csinh(iz) - I*Csin(z);
	cout << dif << endl;

	cout << "cosh(i*z)-cos(z) = 0 ?" << endl;
	dif = Ccosh(iz) - Ccos(z);
	cout << dif << endl;

	cout << "tanh(i*z)-i*tan(z) = 0 ?" << endl;
	dif = Ctanh(iz) - I*Ctan(z);
	cout << dif << endl;

	cout << "acosh(z)-i*acos(z) = 0 ?" << endl;
	dif = Cacosh(z) - I*Cacos(z); //by Gradshteyn and Ryzhik 2000, p. xxx
	cout << dif << endl;

	cout << "asinh(z)-(1/i)*asin(i*z) = 0 ?" << endl;
	dif = Casinh(z) - (1.0/I)*Casin(iz); //by Gradshteyn and Ryzhik 2000, p. xxx
	cout << dif << endl;

	cout << "Did you get values very close to zero ?" << endl;
}

int main()
{
	RealSize C;
	C.SetEffFig(10);

	cerr << title << endl;

	deMoivreFormula();	Wait();
	SomeIdentities();	Ending();
}
