/*  SMPSQRTX.CPP  by K.Tsuru  */ 

const char* const title = "<<<<< A sample program for Sqrt(x). >>>>>";

#include "sn.h"

int main(){
	int fig, output;
	RealSize C;
	SDouble x, y;

	ErrorPuts(title);
	fprintf(stderr, "Effective figures/%u = ? ", DFIGURES);
	fig = GetInt();
	if(fig <= 0) return EXIT_FAILURE;
	C.SetEffFig(fig, C.TEMP_EXTEND);
	fprintf(stderr, "\nYour effective figures in a decimal system = %u .\n", DFIGURES*x.EffFig());

	ErrorPuts("If you choose OFF, it sets Verify(ON).");
	ErrorPut("PreferSpeed() ON(1)/OFF(0) ?= ");
	C.PreferSpeed(GetInt());
	if(C.PreferSpeed()== OFF) C.Verify(ON);

	Timer timer;
	ulong fftused;
	double cpu_time, X;
	int format = x.CRLF | x.INT_PUT | x.SHOW_FIG;

	while(1){
		ErrorPut("To get Sqrt(x), input x =(abort when x <=0) ? ");
		X = GetDouble();
		if(X <= 0.0) break;
		x.FFTUsedTimes(0);
		timer.Start();
		x = Sqrt(X);
		cpu_time = timer.Stop();
		output=1;
		if(x.DFigures()>5000L){
			printf("Output the result Yes(1)/No(0) ?= ");
			output=GetInt();
		}
		if(output) x.Puts(10, 0, 5, format);
		printf("cpu time = %.3f sec\n", cpu_time);
		fftused = x.FFTUsedTimes();
		printf("fftMult() used %lu times.\n", fftused);
		printf("Iteration times in Newton method = %d\n",x.ItrCounts());
		Wait();

		ErrorPuts("Calculating square.");
		x.FFTUsedTimes(0);
		timer.Start();
		y = x*x -X;
		cpu_time = timer.Stop();
		puts("x - sqrt(x)^2 =");
		y.Puts(10, 0, 5, format);
		printf("cpu time = %.3f sec\n", cpu_time);
		fftused = x.FFTUsedTimes();
		x = y = 0.0;	// reduce size
		printf("fftMult() used %lu times. size of x = %u, y = %u\n", fftused, x.Size(), y.Size());
		Wait();
	}
	Ending();
	return EXIT_SUCCESS;
}

